<?php
/**
 * @package		mod_qlwiki
 * @copyright	Copyright (C) 2012 ql.de All rights reserved.
 * @author 		Ingo Holewczuk info@ql.de; Mareike Riegel mareike.riegel@ql.de
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

//no direct access
defined('_JEXEC') or die ('Restricted Access');

jimport('joomla.plugin.plugin');

class plgContentQlwiki extends JPlugin
{

    protected $str_call_start='qlwiki';
    protected $str_call_end='/qlwiki';
    protected $arr_attributes=array('url','title','action','serversettings','login','user','password','user_agent','edit',);

    protected $states=array();
    public $params;

    /**
     * constructor
     *setting language
     */
    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage();
    }
    /**
     * onContentPrepare :: some kind of controller of plugin
     */
    public function onContentPrepare($context, &$article, &$params, $page = 0)
    {
        if ($context=='com_finder.indexer') return true;

        /*set start tag*/
        if (strpos($article->text, $this->str_call_start)===false) return true;
        $article->text=$this->replaceStartTags($article->text);

        /*set end tag*/
        if (strpos($article->text, $this->str_call_end)===false) return true;
        $article->text=$this->replaceEndTags($article->text);

        $article->text=$this->clearTags($article->text);
    }
    /*
    * method to set states
    */
    function setStates()
    {
        $this->states=array();
        foreach ($this->arr_attributes as $k=>$v)
        {
            $this->states[$v]=$this->params->get($v);
        }
        //print_r($this->states);
    }
    /*
     * method to get attributes
     */
    function replaceStartTags($text)
    {
        $matches=$this->getMatches($text,$this->str_call_start);
        if (count($matches)>0)
        {
            foreach ($matches as $match)
            {
                $this->setStates();

                $arr_attributes=$this->getAttributes($match[1]);
                if (is_array($arr_attributes))foreach($arr_attributes as $k=>$v)
                {
                    if(''!=$v)$this->states[$k]=$v;
                }

                $output=$this->getWikiData();

                /*STRIP EDIT BUTTON IF NOT ALLOWED*/
                if (1==$this->states['edit'] OR (2==$this->states['edit'] AND 1==$this->checkUserLoggedIn() AND 1==$this->checkUserAdministrator()));
                else $output=preg_replace('#<span class="editsection">(.*)</span>#Uis', '\\2', $output );
                echo $match[0];
                $text = preg_replace(str_replace('?','\?',"|$match[0]|"), addcslashes($output, '\\$'), $text, 1);

            }
        }
        return $text;
    }

    /*
     * getWikiData
     */
    function getWikiData()
    {

        /*INGO NEUER CODE ZUM AUSTOBEN FUER DICH START*/
        /*DeineVariablen:*/
        //print_r($this->states);
        switch($this->states['serversettings'])
        {
            case 'default' :
                $output=$this->getWikiDataViaDefault();
                break;
            case 'curl' :
                $output=$this->getWikiDataViaCurl();
                break;
            case '3rd_way' :
                $output=$this->getWikiDataVia3();
                break;
            case '4th_way' :
                $output=$this->getWikiDataVia4();
                break;
            case '5th_way' :
                $output=$this->getWikiDataVia5();
                break;
        }
        return $output;
    }
    /*
    * getWikiData defaulty
    */
    function getWikiDataViaDefault()
    {
        $output='';
        if (preg_match('/\?/',$this->states['url'])) $this->states['url'].='&'.$this->getUrlRequests();
        else $this->states['url'].='?'.$this->getUrlRequests();
        if (isset($this->states['user_agent']))ini_set('user_agent',$this->states['user_agent']);
        if (1==$this->states['login'])
        {
            $context = stream_context_create(array('http' => array('header' => "Authorization: Basic " . base64_encode($this->states['user'].':'.$this->states['password']))));
            $output=@file_get_contents($this->states['url'], false, $context);
        }
        else $output=@file_get_contents($this->states['url'], false);
        if (false==$output) JFactory::getApplication()->enqueueMessage($this->get('_name').': '.sprintf(JText::_('PLG_CONTENT_QLWIKI_ERROROCCURRED'),$this->states['title']));
        return $output;
    }
    /*
    * getWikiData via Curl
    */
    function getWikiDataViaCurl()
    {
        $output='';
        /*$this->states['url'].='?'.$this->getUrlRequests();*/
        if (preg_match('/\?/',$this->states['url'])) $this->states['url'].='&'.$this->getUrlRequests();
        else $this->states['url'].='?'.$this->getUrlRequests();
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->states['url']);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        if (1==$this->states['login'])
        {
            curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($ch, CURLOPT_USERPWD, $this->states['user'].':'.$this->states['password']); 
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);                          
            //curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        }                           
        curl_setopt($ch, CURLOPT_USERAGENT, $this->states['user_agent']);
        curl_setopt($ch, CURLINFO_HEADER_OUT, true);
        $output=curl_exec($ch);
        curl_close($ch);
        if (false==$output) JFactory::getApplication()->enqueueMessage($this->get('_name').': '.sprintf(JText::_('PLG_CONTENT_QLWIKI_ERROROCCURRED'),$this->states['title']));
        return $output;
    }
    /*
    * getWikiData via Curl
    */
    function getWikiDataVia3()
    {
        $output='';
        return $output;
    }
    /*
    * getWikiData via Curl
    */
    function getWikiDataVia4()
    {
        $output='';
        return $output;
    }
    /*
    * getWikiData via Curl
    */
    function getWikiDataVia5()
    {
        $output='';
        return $output;
    }
    /*
    * check if user is logged in
    */
    function checkUserLoggedIn()
    {
        $user=JFactory::getUser();
        if ($user->id>0) return true;
        else return false;
    }
    /*
     * check if user is logged in
     */
    function checkUserAdministrator()
    {
        $user=JFactory::getUser();
        if (in_array(8,$user->groups)) return true;
        else return false;
    }

    /*
    * method to get attributes
    */
    function replaceEndTags($text)
    {
        $matches=$this->getMatches($text,$this->str_call_end);
        if (count($matches)>0)
        {
            foreach ($matches as $match)
            {
                $output='';
                $text = preg_replace("|$match[0]|", addcslashes($output, '\\$'), $text, 1);
            }
        }
        return $text;
    }


    /*
     * method to get attributes
     */
    function getAttributes($string)
    {
        $matcheslist=explode(',', $string);
        $arr_attributes=array();
        if (is_array($matcheslist)) foreach ($matcheslist as $k=>$v)
        {
            $v=strip_tags(trim($v));
            $position=strpos($v,'=');
            $front=substr($v,0,$position);
            $back=substr($v,$position+1);
            if (isset($front) AND isset($back)) $arr_attributes[$front]=$back;
            //echo $back;
            unset($arr);
        }
        return $arr_attributes;
    }
    function getUrlRequests()
    {
        $arrRequests=array();
        if('0'!=$this->states['action']) $arrRequests[]='action='.$this->states['action'];
        if(''!=$this->states['title']) $arrRequests[]='title='.$this->states['title'];
        return implode('&',$arrRequests);
    }

    /**
     * method to clear tags
     */
    function clearTags($str)
    {
        $str=preg_replace('?<p></div></p>?','</div>',$str);
        $regex='!<p><div\s(.*?)></p>!';
        preg_match_all($regex, $str, $matches, PREG_SET_ORDER);
        if (isset($matches[0]) AND isset($matches[0][1])) $str=preg_replace($regex,'<div '.$matches[0][1].'>',$str);
        return $str;
    }

    /**
     * method to get matches according to search string
     * @param $text string haystack
     * @param $searchString string needle, string to be searched
     */
    public function getMatches($text,$searchString)
    {
        $searchString=preg_replace('!{\?}!',' ',$searchString);
        $searchString=preg_replace('?/?','\/',$searchString);
        $regex		= '/{'.$searchString.'+(.*?)}/i';
        preg_match_all($regex, $text, $matches, PREG_SET_ORDER);
        return $matches;
    }
}